<?php
	error_reporting(E_ERROR);
	$data = file_get_contents(getenv("CR_INPUT"));
	if (!$data) {
		$data = file_get_contents("php://stdin");
	}
	function parse_vars($str, $depth, &$offset) {
		$variables = array();
		$scopeGroup = $depth == 0 ? '(?:(GLOBAL|LOCAL|ARG|STATIC):)' : '()';
		$pattern = '/(?<=^|[\n\r])'.$scopeGroup.'[ \t]*(?:\((.*?)\))?[ \t]*([^\(\)\n\r]+?)[ \t]+=[ \t]+(0x[a-f0-9]+)?[ \t]*(.*?)[ \t]*(\{\}?)?($|[\n\r])/u';
		while (true) {
			if (preg_match('/^[ \t]*\.\.\.[ \t]*($|[\n\r])/', substr($str, $offset), $m, PREG_OFFSET_CAPTURE)) {
				array_push($variables, array("name" => "..."));
				$offset += strlen($m[0][0])+$m[0][1];
				continue;
			}
			$popOffset = strlen($str);
			if (preg_match('/[ \t]*\}[ \t]*($|[\n\r])/', substr($str, $offset), $m, PREG_OFFSET_CAPTURE)) {
				$popOffset = $offset+strlen($m[0][0])+$m[0][1];
			}
			if (!preg_match($pattern, $str, $match, PREG_OFFSET_CAPTURE, $offset)) {
				$offset = $popOffset;
				break;
			}
			$offset = $match[0][1]+strlen($match[0][0]);
			if ($offset > $popOffset) {
				$offset = $popOffset;
				break;
			}
			$kind = $match[1][0];
			switch ($kind) {
				case "ARG":
					$kind = "parameter";
					break;
				case "LOCAL":
				case "STATIC":
					$kind = "variable";
					break;
				default:
					$kind = strtolower($kind);
			}
			$type = $match[2][0];
			$name = $match[3][0];
			if ($name === "[".count($variables)."]") {
				$name = "".count($variables);
			}
			$hex = $match[4][0];
			if ($hex) {
				$variable["raw_value"] = $hex;
			}
			$value = $match[5][0];
			$variable = array("name" => $name);
			if (strlen($value) > 0) {
				$variable["value"] = $value;
			} else if (strlen($hex)) {
				$variable["value"] = $hex;
			}
			if ($type) {
				$variable["type"] = $type;
			}
			if ($kind) {
				$variable["kind"] = $kind;
			}
			$nested = $match[6];
			if (strlen($nested[0]) == 1) {
				$nested_vars = parse_vars($str, $depth+1, $offset);
				if (count($nested_vars)) {
					$variable["description"] = $variable["value"];
					$variable["value"] = $nested_vars;
				}
			}
			array_push($variables, $variable);
		}
		return $variables;
	}
	$offset = 0;
	$variables = parse_vars($data, 0, $offset);
	echo json_encode($variables);
?>

